// PopupAndMouseHookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PopupAndMouseHook.h"
#include "PopupAndMouseHookDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
static LPCSTR MouseMessages[] = { "WM_MOUSEMOVE",
	"WM_LBUTTONDOWN", "WM_LBUTTONUP", "WM_LBUTTONDBLCLK",
	"WM_RBUTTONDOWN", "WM_RBUTTONUP", "WM_RBUTTONDBLCLK",
	"WM_MBUTTONDOWN", "WM_MBUTTONUP", "WM_MBUTTONDBLCLK", "WM_MOUSEWHEEL" };

static LPCSTR MouseNcMessages[] = { "WM_NCMOUSEMOVE",
	"WM_NCLBUTTONDOWN", "WM_NCLBUTTONUP", "WM_NCLBUTTONDBLCLK",
	"WM_NCRBUTTONDOWN", "WM_NCRBUTTONUP", "WM_NCRBUTTONDBLCLK", 
	"WM_NCMBUTTONDOWN", "WM_NCMBUTTONUP", "WM_NCMBUTTONDBLCLK" };

extern CPopupAndMouseHookApp theApp;

#define UWM_MOUSEHOOK (WM_APP + 100)
#define UWM_SHOW_POPUP (WM_APP + 101)

HHOOK	g_hThreadHook = 0;
HWND	g_hWndNotify = 0;

HHOOK m_hThreadHook;

LRESULT CALLBACK ThreadMouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode >= 0)
	{
		MOUSEHOOKSTRUCT *pMhs = (MOUSEHOOKSTRUCT*)lParam;
		PostMessage(g_hWndNotify, UWM_MOUSEHOOK, wParam, NULL);
	}
	return CallNextHookEx(g_hThreadHook, nCode, wParam, lParam);
}


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPopupAndMouseHookDlg dialog

CPopupAndMouseHookDlg::CPopupAndMouseHookDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPopupAndMouseHookDlg::IDD, pParent)
	, m_enCurHitTest(enHitNC)
	, m_bProc(FALSE)
{
	//{{AFX_DATA_INIT(CPopupAndMouseHookDlg)
	m_csMousePos = _T("");
	m_csMouseMsg = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPopupAndMouseHookDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPopupAndMouseHookDlg)
	DDX_Text(pDX, IDC_STATIC_MOUSE_POS, m_csMousePos);
	DDX_Text(pDX, IDC_STATIC_MOUSE_MSG, m_csMouseMsg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPopupAndMouseHookDlg, CDialog)
	ON_MESSAGE(UWM_MOUSEHOOK, OnMouseHook)
	ON_WM_ENTERMENULOOP()
	//{{AFX_MSG_MAP(CPopupAndMouseHookDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPopupAndMouseHookDlg message handlers

BOOL CPopupAndMouseHookDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	g_hWndNotify = m_hWnd;

	SetHook();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPopupAndMouseHookDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPopupAndMouseHookDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CRect rectClient;

		GetClientRect(rectClient);
		CDialog::OnPaint();
		dc.MoveTo(0, rectClient.Height()/2);
		dc.LineTo(rectClient.right, rectClient.Height()/2);

		dc.MoveTo(rectClient.Width()/2, 0);
		dc.LineTo(rectClient.Width()/2, rectClient.bottom);


	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPopupAndMouseHookDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CPopupAndMouseHookDlg::OnMouseHook(WPARAM wParam, LPARAM lParam)
{
	m_csMouseMsg = "*** Unknown";
	if(WM_MOUSEFIRST <= wParam && wParam <= WM_MOUSELAST)
	{
		m_csMouseMsg.Format("%s", MouseMessages[wParam - WM_MOUSEFIRST]);
//		TRACE("%s\n", MouseMessages[wParam - WM_MOUSEFIRST]);
		
	}
	else if(WM_NCMOUSEMOVE <= wParam && wParam <= WM_NCMBUTTONDBLCLK)
	{
		m_csMouseMsg.Format("%s", MouseNcMessages[wParam - WM_NCMOUSEMOVE]);
//		TRACE("%s\n", MouseNcMessages[wParam - WM_NCMOUSEMOVE]);
	}

	CPoint ptCursor;
	GetCursorPos(&ptCursor);

//	ScreenToClient(&ptCursor);
	m_csMousePos.Format("%d, %d", ptCursor.x, ptCursor.y);

	UpdateData(FALSE);

	theApp.ProcessIdle();
	if(WM_MOUSEMOVE == wParam/* || WM_NCMOUSEMOVE == wParam*/)
	{
		
		if(m_bProc)	//prevent reentry if popup failed
		{
			return 0;
		}
		
		CalcAreas();
		eAreaHitTest Hit = AreaHitTest(ptCursor);
		if(m_enCurHitTest != Hit)
		{
			if(Hit == enHitNC)
			{
				theApp.ProcessIdle();
				return 0;
			}

			m_bProc = TRUE;
			m_enCurHitTest = Hit;
			TRACE("m_enCurHitTest %d\n", m_enCurHitTest);

			EndMenu();

			ShowPopup();
		}
	}
	theApp.ProcessIdle();
	return 0;

}


BOOL CPopupAndMouseHookDlg::DestroyWindow() 
{
	KillHook();	
	return CDialog::DestroyWindow();
}

void CPopupAndMouseHookDlg::CalcAreas()
{
	CRect rectClient;
	GetClientRect(rectClient);

	m_rectAreaArray[0].SetRect(0, 0, rectClient.Width()/2, rectClient.Height()/2);
	m_rectAreaArray[1].SetRect(rectClient.Width()/2, 0, rectClient.Width(), rectClient.Height()/2);
	m_rectAreaArray[2].SetRect(0, rectClient.Height()/2, rectClient.Width()/2, rectClient.Width());
	m_rectAreaArray[3].SetRect(rectClient.Width()/2, rectClient.Height()/2, rectClient.Width(), rectClient.Height());

}

eAreaHitTest CPopupAndMouseHookDlg::AreaHitTest(CPoint pt)
{

	
	for(UINT iIndx = 0; iIndx < 4; iIndx++)
	{
		ClientToScreen(m_rectAreaArray[iIndx]);
	}
	

	for(iIndx = enHit0; iIndx < enHitNC; iIndx++)
	{
		if(m_rectAreaArray[iIndx].PtInRect(pt))
		{
			break;
		}
	}

	return (eAreaHitTest)iIndx;
}
static int iCount = 0;
void CPopupAndMouseHookDlg::ShowPopup()
{
	CMenu menu;
	menu.LoadMenu(IDR_MAIN1);
	
	CMenu *pPopup = menu.GetSubMenu(m_enCurHitTest);
	TRACE("TrackPopupMenu\n");
	
	pPopup->TrackPopupMenu(TPM_LEFTALIGN, m_rectAreaArray[m_enCurHitTest].left, m_rectAreaArray[m_enCurHitTest].top, AfxGetMainWnd());
	
	DWORD dwErr = GetLastError();
	TRACE("*%d GetLastError 0x%.8x\n", iCount, dwErr);
	iCount++;

	if(dwErr == 0x000005a6) //reset to force another call
	{
		m_bProc = FALSE;
		m_enCurHitTest = enHit;
	}
}

void CPopupAndMouseHookDlg::KillHook()
{
	UnhookWindowsHookEx(g_hThreadHook);

}

void CPopupAndMouseHookDlg::SetHook()
{
	g_hThreadHook = SetWindowsHookEx (// install the hook:
		WH_MOUSE,			 // as a mouse hook
		(HOOKPROC)ThreadMouseProc,		 // with the ThreadMouseProc function from this executable
		NULL,					   // for local hook this is null
		AfxGetThread()->m_nThreadID// and finally, the hook should monitor this thread.
);

}

void CPopupAndMouseHookDlg::OnEnterMenuLoop(BOOL bIsTrackPopupMenu)
{
	TRACE("OnEnterMenuLoop\n");
	m_bProc = FALSE;

}

